#ifndef CODE_GFXFILE_CXX
#define CODE_GFXFILE_CXX

/*-----------------------------------------------------------------------
 * Xclasses code file
 * ($Id: gfx_file.cxx,v 1.1.1.1 1998/07/16 19:29:31 cvs Exp $)
 * 
 * Copyright (C) 1998 Jrgen Schmitz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *-----------------------------------------------------------------------
 */

#include "types.h"
#include <Xclasses/gfx_file.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
//#include "include/gfx_file_p.h"

gfx_file::gfx_file() : gfx_object()
{
//	while (!(p=new pgfx_file))
//	{
//		outOfMemory("gfx_file");
//	}
//	p->o=this;
	Name("gfx_file");
}
gfx_file::~gfx_file()
{
//	if (p) delete p;
}

//pgfx_file::pgfx_file(void)
//{
//	adjust=ADJUST_LEFT|ADJUST_TOP;
//}
//pgfx_file::~pgfx_file()
//{
//}

static void draw(class gfx_file *o,class gadget *g,int x,int y,int w,int h,int c)
{
#define PTS1C	10
#define PTS2C	7
	XPoint pts1[PTS1C]={{x+1,y+1},{0,h-2},
					  {w-2,0},{0,-(h-2-5)},
					  {-5,0},{0,-5},
					  {5,5},{-5,0},{0,-5},
					  {-(w-2-5),0}};

	XPoint pts2[PTS2C]={{x+1,y+1},{0,h-2},
					  {w-2,0},{0,-(h-2-5)},
					  {-5,0},{0,-5},
					  {-(w-2-5),0}};
	XSetForeground(o->display(),g->gg_gc(),o->col_white());
//  shape: Complex, Convex, or Nonconvex
	XFillPolygon(o->display(),g->gg_win(),g->gg_gc(),pts2,PTS2C,Convex,CoordModePrevious);
	XSetForeground(o->display(),g->gg_gc(),c);
	XDrawLines(o->display(),g->gg_win(),g->gg_gc(),pts1,PTS1C,CoordModePrevious);
}

void gfx_file::Adjust(int a)
{
//	p->adjust=a;
}
void gfx_file::draw_normal(class gadget *g,int x,int y,int w,int h)
{
	draw(this,g,x,y,w,h,col_text());
}
void gfx_file::draw_selected(class gadget *g,int x,int y,int w,int h)
{
	draw(this,g,x+1,y+1,w,h,col_selectedtext());
}
void gfx_file::draw_locked(class gadget *g,int x,int y,int w,int h)
{
	draw(this,g,x,y,w,h,col_text());
}
void gfx_file::draw_selectedlocked(class gadget *g,int x,int y,int w,int h)
{
	draw(this,g,x+1,y+1,w,h,col_selectedtext());
}

int gfx_file::height(class gadget *g)
{
	return NOLIMIT;
}
int gfx_file::width(class gadget *g)
{
	return NOLIMIT;
}

#endif
