#ifndef CODE_GFXTEXTP_H
#define CODE_GFXTEXTP_H

/*-----------------------------------------------------------------------
 * Xclasses header file
 * ($Id: gfx_text_p.h,v 1.1.1.1 1998/07/16 19:29:31 cvs Exp $)
 * 
 * Copyright (C) 1998 Jrgen Schmitz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *-----------------------------------------------------------------------
 */

#include <Xclasses/gfx_text.h>

struct gtxt_part
{
	struct gtxt_part 	*next;
	int					length;
	int					under;
	int					font;
	int					width;
	int					ux1,ux2;
	char				text[1];
};
struct gtxt_line
{
	struct gtxt_line	*next;
	int					width;
	int					height;
	int					baseline;
	struct gtxt_part	*parts;
};

class pgfx_text
{
	friend class gfx_text;

public:
	class gfx_text *o;

	int 			width;
	int 			height;
	gtxt_line		*teile;
	int				adjust;
	int				allowunderline:1,
					free:1;

	pgfx_text(void);
	~pgfx_text();

	void freemem(void);
	gtxt_part *addpart(gtxt_line *g,gtxt_part *p1,char *c1,char *c2,int f);
	void draw(class gadget *g,int x,int y,int w,int h,int col);
	void calcSize(gadget *g);
};

/*
class pgfx_text
{
	friend class gfx_text;

public:
	struct parts
	{
		struct parts *next;
		int 		length;
		int			under;
		int			font;
		int			newline;
		char 		text[1];
	};

	class gfx_text *o;

	int 			width;
	int 			height;
	int				z;
	parts			*teile;
	int				adjust;
	int				allowunderline:1,
					free:1;

	int X(int w,int cw);
	int Y(int h,int f);
	void UL(gadget *g,int x,int y,parts *p);
	void draw(class gadget *g,int x,int y,int w,int h,int col);
	void calcSize(gadget *g);
	
	pgfx_text(void);
	~pgfx_text();
};
*/
#endif
