/*-----------------------------------------------------------------------
 * Xclasses code file
 * ($Id: chartable.cxx,v 1.1 1998/08/08 18:48:02 schmitzj Exp $)
 * 
 * Copyright (C) 1998 Ralf Becker
 *
 * HTML Parser system
 * (c) 1998 by Jrgen Schmitz - all rights reserved
 * THIS IS NOT GPL OR SOMETHING OTHER FREE LICENSE!!
 * it may only be used together with Xclasses!
 *-----------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include "include/chartable.h"

// Liste aller &...;-Ausdruecke...alphabetisch sortiert WICHTIG!
//
CharTable::TranslateCode CharTable::translate[COUNT] = {
	{ "Aacute",	193 },	//   0
	{ "Acirc",	194 },	//   1
	{ "Aelig",	198 },	//   2
	{ "Agrave",	192 },	//   3
	{ "Aring",	197 },	//   4
	{ "Atilde",	195 },	//   5
	{ "Auml",	196 },	//   6
	{ "Ccedil",	199 },	//   7
	{ "ETH",	208 },	//   8
	{ "Eacute",	201 },	//   9
	{ "Ecirc",	202 },	//  10
	{ "Egrave",	200 },	//  11
	{ "Euml",	203 },	//  12
	{ "Iacute",	205 },	//  13
	{ "Icirc",	206 },	//  14
	{ "Igrave",	204 },	//  15
	{ "Iuml",	207 },	//  16
	{ "Ntilde",	209 },	//  17
	{ "Oacute",	211 },	//  18
	{ "Ocirc",	212 },	//  19
	{ "Ograve",	210 },	//  20
	{ "Oslash",	216 },	//  21
	{ "Otilde",	213 },	//  22
	{ "Ouml",	214 },	//  23
	{ "THORN",	222 },	//  24
	{ "Uacute",	218 },	//  25
	{ "Ucirc",	219 },	//  26
	{ "Ugrave",	217 },	//  27
	{ "Uuml",	220 },	//  28
	{ "Yacute",	221 },	//  29
	{ "aacute",	225 },	//  30
	{ "acirc",	226 },	//  31
	{ "acute",	180 },	//  32
	{ "aelig",	230 },	//  33
	{ "agrave",	224 },	//  34
	{ "amp",	'&'	},	//  35
	{ "aring",	229 },	//  36
	{ "atilde",	227 },	//  37
	{ "auml",	228 },	//  38
	{ "brvbar",	166 },	//  39
	{ "bsp",	' ' },	//  40
	{ "ccedil",	231 },	//  41
	{ "cedil",	184 },	//  42
	{ "cent",	162 },	//  43
	{ "copy",	169 },	//  44
	{ "curren",	164 },	//  45
	{ "deg",	176 },	//  46
	{ "divide",	247 },	//  47
	{ "eacute",	233 },	//  48
	{ "ecirc",	234 },	//  49
	{ "egrave",	232 },	//  50
	{ "eth",	240 },	//  51
	{ "euml",	235 },	//  52
	{ "frac12",	189 },	//  53
	{ "frac14",	188 },	//  54
	{ "frac34",	190 },	//  55
	{ "gt",		'>'	},	//  56
	{ "iacute",	237 },	//  57
	{ "icirc",	238 },	//  58
	{ "iexcl",	161 },	//  59
	{ "igrave",	236 },	//  60
	{ "iquest",	191 },	//  61
	{ "iuml",	239 },	//  62
	{ "laquo",	171 },	//  63
	{ "lt",		'<'	},	//  64
	{ "macr",	175 },	//  65
	{ "micro",	181 },	//  66
	{ "middot",	183 },	//  67
	{ "nbsp",	NBSP},	//  68
	{ "not",	172 },	//  69
	{ "ntilde",	241 },	//  70
	{ "oacute",	243 },	//  71
	{ "ocirc",	244 },	//  72
	{ "ograve",	242 },	//  73
	{ "ordf",	170 },	//  74
	{ "ordm",	186 },	//  75
	{ "oslash",	248 },	//  76
	{ "otilde",	245 },	//  77
	{ "ouml",	246 },	//  78
	{ "para",	182 },	//  79
	{ "plusmn",	177 },	//  80
	{ "pound",	163 },	//  81
	{ "quot",	'"'	},	//  82
	{ "raquo",	187 },	//  83
	{ "reg",	174 },	//  84
	{ "sect",	167 },	//  85
	{ "shy",	173 },	//  86
	{ "sup1",	185 },	//  87
	{ "sup2",	178 },	//  88
	{ "sup3",	179 },	//  89
	{ "szlig",	223 },	//  90
	{ "thorn",	254 },	//  91
	{ "times",	215 },	//  92
	{ "uacute",	250 },	//  93
	{ "ucirc",	251 },	//  94
	{ "ugrave",	249 },	//  95
	{ "uml",	168 },	//  96
	{ "uuml",	252 },	//  97
	{ "yacute",	253 },	//  98
	{ "yen",	165 },	//  99
	{ "yuml",	255 },	// 100
};

int CharTable::Translate(char *n) {

	char name[20];

	if (!n && !*n) return 0;
	
	if (*n == '&') n++;
	
	name[0] = 0;
	strncat(name, n, sizeof(name)-1);

	if (name[strlen(name)-1] == ';')
		name[strlen(name)-1] = 0;

	// Binaere Suche in der Uebersetzungtabelle...
	//
	int lt = 0, rt = COUNT-1;
	int found = 0;

	while (lt <= rt && !found) {
		int m = lt + (rt - lt)/2;
		int c = strcmp(translate[m].ascii, name);
		if (c < 0) lt = m + 1;
		else if (c > 0) rt = m - 1;
		else found = m;
	}
	return found ? translate[found].code : ' ';
}
