#ifndef CODE_HTMLTEXTBOXP_H
#define CODE_HTMLTEXTBOXP_H

/*-----------------------------------------------------------------------
 * Xclasses header file
 * ($Id: htmltextbox_p.h,v 1.1.1.1 1998/07/16 19:29:30 cvs Exp $)
 * 
 * Copyright (C) 1998 Jrgen Schmitz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *-----------------------------------------------------------------------
 */

#include <Xclasses/htmltextbox.h>
#include <Xclasses/dlist.h>

#define MEMBLOCKSIZE	1000

class phtmltextbox
{
	friend class htmltextbox;
public:
	htmltextbox *o;

	char	*text;
	int		size;
	int		used;
	int		old_w;

	int		md_dl:1,
			md_dt:1,
			md_dd:1,
			md_ol:1,
			md_ul:1,
			md_li:1,
			free:1;
	int		ol_counter;

    phtmltextbox();
	~phtmltextbox();

	void checkMem(void);
	void RemoveAll(void);
	void calcText(void);
	int findMatch(char,char *);
	char *findSymbol(char *,int);
	char *findTag(char *,int);
};

#endif
